﻿using System.Collections.Generic;
using System.Linq;

namespace DomainModel.ReviewDomainModel.Entity
{
    using Specification;

    public class ReviewCollection : List<Review>
    {
        public List<Review> GetUiReviews()
        {
            Specification spec = SpecificationFactory.CreateGetUiReviewsSpecification();
            var list = this.Where(review => spec.IsSatisifedBy(review));
            return list.ToList();
        }

        public List<Review> GetServiceReviews()
        {
            Specification spec = SpecificationFactory.CreateGetServiceReviewSpecification();
            var list = this.Where(review => spec.IsSatisifedBy(review));
            return list.ToList();
        }

        public List<Review> GetUiAndServiceReviews()
        {
            Specification specUi = SpecificationFactory.CreateGetUiReviewsSpecification();
            Specification specService = SpecificationFactory.CreateGetServiceReviewSpecificationWithSwitch();

            var list = this.Where(review => specUi.IsSatisifedBy(review) || specService.IsSatisifedBy(review));
            return list.ToList();
        }
    }
}
