﻿using System;

namespace DomainModel.ReviewDomainModel.Specification
{
    using DomainModel.ReviewDomainModel.Entity;

    internal class SpecificationFactory
    {
        internal static Specification CreateGetUiReviewsSpecification()
        {
            Specification spec = new Specification();
            spec.Expression = (review) => review.Id > 999 && review.LastEditDate > DateTime.Now;
            return spec;
        }

        internal static Specification CreateGetServiceReviewSpecification()
        {
            Specification spec = new Specification();
            spec.Expression = (review) => review.Id > 50 && review.LastEditDate > DateTime.Now;
            return spec;
        }

        internal static Specification CreateGetServiceReviewSpecificationWithSwitch()
        {
            SpecificationWithSwitchConfig spec = new SpecificationWithSwitchConfig() { Enable = false };
            spec.Expression = (review) => review.Id > 50 && review.LastEditDate > DateTime.Now;
            return spec;
        }
    }
}
